classification
Title: Obsolete SSLFakeFile in smtplib?
Type: behavior Stage: resolved
Components: Library (Lib) Versions: Python 3.3
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: catalin.iacob, giampaolo.rodola, janssen, kasun, pitrou, python-dev, sijinjoseph
Priority: low Keywords: easy, patch

Created on 2011-04-20 20:54 by pitrou, last changed 2011-06-06 17:19 by pitrou. This issue is now closed.

Files
File name Uploaded Description Edit
remove_sslfakefile_v1.patch catalin.iacob, 2011-05-28 19:39 review
Messages (4)
msg134182 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2011-04-20 20:54
smtplib uses a wrapper class "SSLFakeFile" in order to call readline() on an SSL socket. But modern SSL sockets have makefile(), so using that wrapper class really shouldn't necessary (of course, it must be investigated whether that's true - and we have no tests for SMTP-over-SSL AFAIK :/).
msg137145 - (view) Author: Catalin Iacob (catalin.iacob) * Date: 2011-05-28 19:39
Attached v1 of patch. Please review.

There are some tests using GMail in test_smtpnet.py. They still pass with the patch. I also did manual tests with GMail with both SMTP + starttls and SMTP_SSL.

The idea of the patch is that SMTP.getreply is already doing:
  if self.file is None:
      self.file = self.sock.makefile('rb')
Therefore, the patch invalidates self.file by setting it to None every time self.sock is (re-)assigned to something.

For consistency, setting self.file to None is also done in LMTP.connect when setting self.sock to a Unix socket although it's not necessarily needed there. Not doing this makes the following scenario fail: create an LMTP instance, call connect, send and read some data (self.file gets initialized), call connect again with an Unix socket, reading more data now uses self.file referring to old socket. But I'm not sure if this scenario is a bug or a misuse of the API, aka you shouldn't call connect twice on the same instance.

Note that I didn't test LMTP. Should I or is it obvious enough that the change is ok?
msg137756 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2011-06-06 17:13
> Note that I didn't test LMTP. Should I or is it obvious enough that the change is ok?

Thank you for the patch! I think it's ok. I'll give it a try and commit
if everything is alright.
msg137757 - (view) Author: Roundup Robot (python-dev) Date: 2011-06-06 17:18
New changeset b68390b6dbfd by Antoine Pitrou in branch 'default':
Issue #11893: Remove obsolete internal wrapper class `SSLFakeFile` in the smtplib module.
http://hg.python.org/cpython/rev/b68390b6dbfd
History
Date User Action Args
2011-06-06 17:19:10pitrousetstatus: open -> closed
resolution: fixed
stage: resolved
2011-06-06 17:18:02python-devsetnosy: + python-dev
messages: + msg137757
2011-06-06 17:13:28pitrousetmessages: + msg137756
2011-05-28 19:39:34catalin.iacobsetfiles: + remove_sslfakefile_v1.patch

nosy: + catalin.iacob
messages: + msg137145

keywords: + patch
2011-04-25 22:19:50sijinjosephsetnosy: + sijinjoseph
2011-04-20 20:54:41pitroucreate